Subject: Re: MMIO and gcc re-ordering issue

From: Haavard Skinnemoen <[email-masked]>
Date: Fri, 30 May 2008 08:07:00 +0200

On Fri, 30 May 2008 11:13:23 +1000
Benjamin Herrenschmidt <[email-masked]> wrote:

> > Currently, this is the only interface I know that can do native-endian
> > accesses, so if you take it away, I'm gonna need an alternative
> > interface that doesn't do byteswapping.  
> 
> Are you aware that these also don't provide any ordering guarantee ?

Yes, but I am not aware of any alternative.

I think the drivers I've written have the necessary barriers (or dma
ops with implicit barriers) that they don't actually depend on any
DMA vs. MMIO ordering guarantees. I hope MMIO vs. MMIO ordering is
guaranteed though?

Haavard